part of mahg_essential_package;

abstract class MahgController {
  /// bust feild
  bool busy = false;

  /// on dispose
  void dispose() {}

  /// the state
  State? state;

  BuildContext? _context;

  /// the local function for setState
  void Function(VoidCallback)? setStateFunction;

  /// fire the function after the page is mounted
  ///
  /// [Alert] it can be fired multiple times
  Future<void> onDisplayed(Widget page, bool isDisplayed) async {}

  void init(Widget page);
  Future initLate(Widget page);

  /// buld context for the controller
  BuildContext get context {
    return state?.context ?? _context!;
  }

  /// setState
  setState() {
    if (setStateFunction != null) {
      setStateFunction?.call(() {});
    } else if (state != null && (state?.mounted ?? false)) {
      state?.setState(() {});
    }
  }

  /// dismiss the loading popup
  setResume() {
    if (!busy) return;
    busy = false;
    Navigator.of(context, rootNavigator: true).pop();
  }
}
