library mahg_essential_package;

import 'dart:ui';

import 'package:beamer/beamer.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:http_parser/http_parser.dart';
import 'package:lifecycle/lifecycle.dart'
    show
        defaultLifecycleObserver,
        LifecycleAware,
        LifecycleMixin,
        LifecycleEvent;

import 'dart:convert';
import 'dart:io';

import 'package:path_provider/path_provider.dart' as path_provider;
import 'package:http/http.dart' as http;
import 'package:path/path.dart' as path;

import 'package:flutter/foundation.dart'
    show defaultTargetPlatform, kDebugMode, kIsWeb;

import 'package:shared_preferences/shared_preferences.dart';

import 'dart:async';
import 'package:intl/intl.dart' as intl;

//Widgets
part 'widgets/dash_widget.dart';
part 'widgets/scrollable_widget.dart';
part 'widgets/custom_form_field_validator.dart';
part 'widgets/alert_message.dart';
part 'widgets/circular_Image.dart';
part 'widgets/restart_widget.dart';
part 'widgets/text_field_widget.dart';
part 'widgets/app_button.dart';
part 'widgets/app_text_field_ex.dart';
part 'widgets/mahg_stateful_widget.dart';
//Utilities
part 'utilities/loading_over_page.dart';
part 'utilities/app_scroll_behavior.dart';
//Services
part 'services/layout_services.dart';
part 'services/config_service.dart';
part 'services/app_localization.dart';
part 'services/api_service.dart';
part 'services/beamer_service.dart';
//Models
part 'models/mahg_model.dart';
part 'models/process_result.dart';
//Controllers
part 'controllers/mahg_controller.dart';
