part of mahg_essential_package;

enum MessageType { success, error, alert }

class AlertMessage {
  static Future<T?> showMessage<T>(
      BuildContext context, String title, String body, MessageType type) {
    Widget getIcon() {
      switch (type) {
        case MessageType.success:
          return Icon(
            Icons.done,
            size: 40.0,
            color: Colors.greenAccent,
          );
        case MessageType.error:
          return Icon(
            Icons.error,
            size: 40.0,
            color: Colors.redAccent,
          );
        case MessageType.alert:
          return Icon(
            Icons.add_alert,
            size: 40.0,
            color: Colors.yellow,
          );
      }
    }

    return showDialog<T>(
        context: context,
        builder: (c) => AlertDialog(
            title: Row(
              children: <Widget>[
                Expanded(
                    child: Text(
                  title,
                  maxLines: 3,
                  softWrap: true,
                  style: TextStyle(),
                )),
                SizedBox(width: 15.0),
                getIcon()
              ],
            ),
            content: Text(body, maxLines: 3, softWrap: true)
            // actions: <Widget>[
            //   new FlatButton(
            //     child: new Text("OK"),
            //     onPressed: () => Navigator.pop(context),
            //   )
            // ],
            ));
  }
}
