part of mahg_essential_package;

class CircularImage extends StatelessWidget {
  final ImageProvider<Object>? imageProvider;
  final Color color;
  final double size;
  final double solidWidth;

  const CircularImage(
      {Key? key,
      this.imageProvider,
      required this.color,
      required this.size,
      required this.solidWidth})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        Container(
          width: size,
          height: size,
          decoration: BoxDecoration(
              shape: BoxShape.circle,
              border: Border.all(
                  color: color, width: solidWidth, style: BorderStyle.solid),
              image: DecorationImage(
                fit: BoxFit.cover,
                image: imageProvider!,

                // imageId != null || imageId == ''
                //     ? ImageService.getImageEx(imageId)!.image
                //     : AssetImage('assets/emtyAvatar.png')
              )),
        ),
      ],
    );
  }
}
