part of mahg_essential_package;

class DashWidget extends StatelessWidget {
  final double thickness;
  final Color color;
  final Axis axis;

  const DashWidget(
      {this.thickness = 1,
      this.color = Colors.black,
      this.axis = Axis.horizontal});

  @override
  Widget build(BuildContext context) {
    return axis == Axis.vertical
        ? LayoutBuilder(
            builder: (BuildContext context, BoxConstraints constraints) {
              final boxHeight = constraints.constrainHeight();
              final dashWidth = thickness;
              const dashHeight = 3.0;
              final dashCount = (boxHeight / (2 * dashHeight)).floor();
              return Flex(
                children: List.generate(dashCount, (_) {
                  return SizedBox(
                    width: dashWidth,
                    height: dashHeight,
                    child: DecoratedBox(
                      decoration: BoxDecoration(color: color.withOpacity(.5)),
                    ),
                  );
                }),
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                direction: Axis.vertical,
              );
            },
          )
        : LayoutBuilder(
            builder: (BuildContext context, BoxConstraints constraints) {
              final boxWidth = constraints.constrainWidth();
              const dashWidth = 3.0;
              final dashHeight = thickness;
              final dashCount = (boxWidth / (2 * dashWidth)).floor();
              return Flex(
                children: List.generate(dashCount, (_) {
                  return SizedBox(
                    width: dashWidth,
                    height: dashHeight,
                    child: DecoratedBox(
                      decoration: BoxDecoration(color: color.withOpacity(.5)),
                    ),
                  );
                }),
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                direction: axis,
              );
            },
          );
  }
}
